//////////////////////////////////////////////////////////////////
// Impulse C is Copyright(c) 2012 Impulse Accelerated Technologies, Inc.
//
// memtest_sw.c: includes the software test bench processes and
// main() function.
//
#ifdef WIN32
#include <windows.h>
#else
#include <stdlib.h>
#include "pico_wrapper.h"
#endif
#include <stdio.h>
#include <fcntl.h>
#include "co.h"
#include "memtest.h"

extern co_architecture co_initialize(void *);

void Testbench(co_stream ipassdata, co_stream opassdata, co_memory mem)
{
	int i;
	co_uint128 data;
	int64 test[NUM_ELEMENTS];

	data[0] = 0;
	data[1] = 0;
	data[2] = 0;
	data[3] = 0;

	for (i = 0; i < NUM_ELEMENTS; i++)
	{
		test[i] = i;
		data[0] += i;
	}
	printf("sw total: %d\n", (int) data[0]);

	co_stream_open(ipassdata, O_WRONLY, INT_TYPE(STREAMWIDTH));
	co_stream_open(opassdata, O_RDONLY, INT_TYPE(STREAMWIDTH));

	printf("writing memory\n");
	co_memory_writeblock(mem, 0, test, sizeof(test));

	printf("writing stream\n");
	data[0] = NUM_ELEMENTS;
	co_stream_write(ipassdata, &data, sizeof(data));

	printf("reading stream\n");
	co_stream_read(opassdata, &data, sizeof(data));
	printf("hw total: %d\n", (int) data[0]);

	memset(test, 0, sizeof(test));

	printf("reading memory\n");
	co_memory_readblock(mem, 0, test, sizeof(test));

	data[0] = 0;
	for (i = 0; i < NUM_ELEMENTS; i++)
	{
		if (test[i] != data[0])
			printf("error test[%d]=%d (expecting %d)\n", i, (int) test[i],
					(int) data[0]);
		data[0] += i;
	}

	co_stream_close(ipassdata);
	co_stream_close(opassdata);
}

int main(int argc, char *argv[])
{
	co_architecture my_arch;
	void *param = NULL;
	int c;
	char *bitFileNameP = "../../export_hw/Pico_Toplevel.bit";

	IF_NSIM(
		if (Pico_LoadFPGA(bitFileNameP) < 0)
		{
			fprintf(stderr, "\nFailed to load FPGA from file %s, exiting.\n", bitFileNameP); exit(-1);
		}
	)

	my_arch = co_initialize(param);
	co_execute(my_arch);

	printf("done.\n");
	IF_SIM(printf("Press Enter to exit.\n"); getch();)

	return (0);
}
